ClassLoader

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.lang
Class ClassLoader

    java.lang.Object
      java.lang.ClassLoader

Direct Known Subclasses:
  SecureClassLoader

    public abstract class ClassLoader

extends Object

A class loader is an object that is responsible for loading classes. The class `ClassLoader` is an abstract class. Given the name of a class, a class loader should attempt to locate or generate data that constitutes a definition for the class. A typical strategy is to transform the name into a file name and then read a "class file" of that name from a file system.

Every ``Class`` object contains a `reference` to the `ClassLoader` that defined it.

`Class` objects for array classes are not created by class loaders, but are created automatically as required by the Java runtime. The class loader for an array class, as returned by `Class.getClassLoader()` is the same as the class loader for its element type; if the element type is a primitive type, then the array class has no class loader.

Applications implement subclasses of `ClassLoader` in order to extend the manner in which the Java virtual machine dynamically loads classes.

Class loaders may typically be used by security managers to indicate security domains.

The `ClassLoader` class uses a delegation model to search for classes and resources. Each instance of `ClassLoader` has an associated parent class loader. When requested to find a class or resource, a `ClassLoader` instance will delegate the search for the class or resource to its parent class loader before attempting to find the class or resource itself. The virtual machine's built-in class loader, called the "bootstrap class loader", does not itself have a parent but may serve as the parent of a `ClassLoader` instance.

Normally, the Java virtual machine loads classes from the local file system in a platform-dependent manner. For example, on UNIX systems, the virtual machine loads classes from the directory defined by the `CLASSPATH` environment variable.

However, some classes may not originate from a file; they may originate from other sources, such as the network, or they could be constructed by an application. The method ``defineClass`` converts an array of bytes into an instance of class `Class`. Instances of this newly defined class can be created using ``Class.newInstance``.

The methods and constructors of objects created by a class loader may reference other classes. To determine the class(es) referred to, the Java virtual machine invokes the ``loadClass`` method of the class loader that originally created the class.

For example, an application could create a network class loader to download class files from a server. Sample code might look like:

>        ClassLoader loader = new NetworkClassLoader(host, port);
>        Object main = loader.loadClass("Main", true).newInstance();
>               . . .

The network class loader subclass must define the methods ``findClass`` and `loadClassData` to load a class from the network. Once it has downloaded the bytes that make up the class, it should use the method ``defineClass`` to create a class instance. A sample implementation is:

>          class NetworkClassLoader extends ClassLoader {
>              String host;
>              int port;

>              public Class findClass(String name) {
>                  byte[] b = loadClassData(name);
>                  return defineClass(name, b, 0, b.length);
>              }

>              private byte[] loadClassData(String name) {
>                  // load the class data from the connection
>                   . . .
>              }
>          }

Since:
  1.0
Version:
  1.159, 07/27/05
See Also:
  `resolveClass(Class)`

Method Summary
`void` | `clearAssertionStatus()` Sets the default assertion status for this class loader to `false` and discards any package defaults or class assertion status settings associated with the class loader.
`ClassLoader` | `getParent()` Returns the parent class loader for delegation.
`URL` | `getResource(String name)` Finds the resource with the given name.
`InputStream` | `getResourceAsStream(String name)` Returns an input stream for reading the specified resource.
`Enumeration` | `getResources(String name)` Finds all the resources with the given name.
`static ClassLoader` | `getSystemClassLoader()` Returns the system class loader for delegation.
`static URL` | `getSystemResource(String name)` Find a resource of the specified name from the search path used to load classes.
`static InputStream` | `getSystemResourceAsStream(String name)` Open for reading, a resource of the specified name from the search path used to load classes.
`static Enumeration` | `getSystemResources(String name)` Finds all resources of the specified name from the search path used to load classes.
`Class` | `loadClass(String name)` Loads the class with the specified name.
`void` | `setClassAssertionStatus(String className, boolean enabled)` Sets the desired assertion status for the named top-level class in this class loader and any nested classes contained therein.
`void` | `setDefaultAssertionStatus(boolean enabled)` Sets the default assertion status for this class loader.
`void` | `setPackageAssertionStatus(String packageName, boolean enabled)` Sets the package default assertion status for the named package.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### loadClass

    public Class loadClass(String name)
                    throws ClassNotFoundException

  Loads the class with the specified name. This method searches for classes in the same manner as the `loadClass(String, boolean)` method. It is invoked by the Java virtual machine to resolve class references. Invoking this method is equivalent to invoking ``loadClass(name, false)``.

  Parameters:
    `name` - The name of the class
  Returns:
    The resulting `Class` object
  Throws:
    `ClassNotFoundException` - If the class was not found

### getResource

    public URL getResource(String name)

  Finds the resource with the given name. A resource is some data (images, audio, text, etc) that can be accessed by class code in a way that is independent of the location of the code.

  The name of a resource is a '`/`'-separated path name that identifies the resource.

  This method will first search the parent class loader for the resource; if the parent is `null` the path of the class loader built-in to the virtual machine is searched. That failing, this method will invoke `findResource(String)` to find the resource.

  Parameters:
    `name` - The resource name
  Returns:
    A `URL` object for reading the resource, or `null` if the resource could not be found or the invoker doesn't have adequate privileges to get the resource.
  Since:
    1.1

### getResources

    public final Enumeration getResources(String name)
                                   throws IOException

  Finds all the resources with the given name. A resource is some data (images, audio, text, etc) that can be accessed by class code in a way that is independent of the location of the code.

  The name of a resource is a `/`-separated path name that identifies the resource.

  The search order is described in the documentation for `getResource(String)`.

  Parameters:
    `name` - The resource name
  Returns:
    An enumeration of ``URL`` objects for the resource. If no resources could be found, the enumeration will be empty. Resources that the class loader doesn't have access to will not be in the enumeration.
  Throws:
    `IOException` - If I/O errors occur
  Since:
    1.2
  See Also:
    `findResources(String)`

### getSystemResource

    public static URL getSystemResource(String name)

  Find a resource of the specified name from the search path used to load classes. This method locates the resource through the system class loader (see `getSystemClassLoader()`).

  Parameters:
    `name` - The resource name
  Returns:
    A ``URL`` object for reading the resource, or `null` if the resource could not be found
  Since:
    1.1

### getSystemResources

    public static Enumeration getSystemResources(String name)
                                          throws IOException

  Finds all resources of the specified name from the search path used to load classes. The resources thus found are returned as an ``Enumeration`` of ``URL`` objects.

  The search order is described in the documentation for `getSystemResource(String)`.

  Parameters:
    `name` - The resource name
  Returns:
    An enumeration of resource ``URL`` objects
  Throws:
    `IOException` - If I/O errors occur
  Since:
    1.2

### getResourceAsStream

    public InputStream getResourceAsStream(String name)

  Returns an input stream for reading the specified resource.

  The search order is described in the documentation for `getResource(String)`.

  Parameters:
    `name` - The resource name
  Returns:
    An input stream for reading the resource, or `null` if the resource could not be found
  Since:
    1.1

### getSystemResourceAsStream

    public static InputStream getSystemResourceAsStream(String name)

  Open for reading, a resource of the specified name from the search path used to load classes. This method locates the resource through the system class loader (see `getSystemClassLoader()`).

  Parameters:
    `name` - The resource name
  Returns:
    An input stream for reading the resource, or `null` if the resource could not be found
  Since:
    1.1

### getParent

    public final ClassLoader getParent()

  Returns the parent class loader for delegation. Some implementations may use `null` to represent the bootstrap class loader. This method will return `null` in such implementations if this class loader's parent is the bootstrap class loader.

  If a security manager is present, and the invoker's class loader is not `null` and is not an ancestor of this class loader, then this method invokes the security manager's ``checkPermission`` method with a ``RuntimePermission("getClassLoader")`` permission to verify access to the parent class loader is permitted. If not, a `SecurityException` will be thrown.

  Returns:
    The parent `ClassLoader`
  Throws:
    `SecurityException` - If a security manager exists and its `checkPermission` method doesn't allow access to this class loader's parent class loader.
  Since:
    1.2

### getSystemClassLoader

    public static ClassLoader getSystemClassLoader()

  Returns the system class loader for delegation. This is the default delegation parent for new `ClassLoader` instances, and is typically the class loader used to start the application.

  This method is first invoked early in the runtime's startup sequence, at which point it creates the system class loader and sets it as the context class loader of the invoking `Thread`.

  The default system class loader is an implementation-dependent instance of this class.

  If the system property "`java.system.class.loader`" is defined when this method is first invoked then the value of that property is taken to be the name of a class that will be returned as the system class loader. The class is loaded using the default system class loader and must define a public constructor that takes a single parameter of type `ClassLoader` which is used as the delegation parent. An instance is then created using this constructor with the default system class loader as the parameter. The resulting class loader is defined to be the system class loader.

  If a security manager is present, and the invoker's class loader is not `null` and the invoker's class loader is not the same as or an ancestor of the system class loader, then this method invokes the security manager's ``checkPermission`` method with a ``RuntimePermission("getClassLoader")`` permission to verify access to the system class loader. If not, a `SecurityException` will be thrown.

  Returns:
    The system `ClassLoader` for delegation, or `null` if none
  Throws:
    `SecurityException` - If a security manager exists and its `checkPermission` method doesn't allow access to the system class loader.
    `IllegalStateException` - If invoked recursively during the construction of the class loader specified by the "`java.system.class.loader`" property.
    `Error` - If the system property "`java.system.class.loader`" is defined but the named class could not be loaded, the provider class does not define the required constructor, or an exception is thrown by that constructor when it is invoked. The underlying cause of the error can be retrieved via the `Throwable.getCause()` method.

### setDefaultAssertionStatus

    public void setDefaultAssertionStatus(boolean enabled)

  Sets the default assertion status for this class loader. This setting determines whether classes loaded by this class loader and initialized in the future will have assertions enabled or disabled by default. This setting may be overridden on a per-package or per-class basis by invoking `setPackageAssertionStatus(String, boolean)` or `setClassAssertionStatus(String, boolean)`.

  Parameters:
    `enabled` - `true` if classes loaded by this class loader will henceforth have assertions enabled by default, `false` if they will have assertions disabled by default.
  Since:
    1.4

### setPackageAssertionStatus

    public void setPackageAssertionStatus(String packageName,
                                          boolean enabled)

  Sets the package default assertion status for the named package. The package default assertion status determines the assertion status for classes initialized in the future that belong to the named package or any of its "subpackages".

  A subpackage of a package named p is any package whose name begins with "`p.`". For example, `javax.swing.text` is a subpackage of `javax.swing`, and both `java.util` and `java.lang.reflect` are subpackages of `java`.

  In the event that multiple package defaults apply to a given class, the package default pertaining to the most specific package takes precedence over the others. For example, if `javax.lang` and `javax.lang.reflect` both have package defaults associated with them, the latter package default applies to classes in `javax.lang.reflect`.

  Package defaults take precedence over the class loader's default assertion status, and may be overridden on a per-class basis by invoking `setClassAssertionStatus(String, boolean)`.

  Parameters:
    `packageName` - The name of the package whose package default assertion status is to be set. A `null` value indicates the unnamed package that is "current" (Java Language Specification, section 7.4.2).
    `enabled` - `true` if classes loaded by this classloader and belonging to the named package or any of its subpackages will have assertions enabled by default, `false` if they will have assertions disabled by default.
  Since:
    1.4

### setClassAssertionStatus

    public void setClassAssertionStatus(String className,
                                        boolean enabled)

  Sets the desired assertion status for the named top-level class in this class loader and any nested classes contained therein. This setting takes precedence over the class loader's default assertion status, and over any applicable per-package default. This method has no effect if the named class has already been initialized. (Once a class is initialized, its assertion status cannot change.)

  If the named class is not a top-level class, this invocation will have no effect on the actual assertion status of any class, and its return value is undefined.

  Parameters:
    `className` - The fully qualified class name of the top-level class whose assertion status is to be set.
    `enabled` - `true` if the named class is to have assertions enabled when (and if) it is initialized, `false` if the class is to have assertions disabled.
  Since:
    1.4

### clearAssertionStatus

    public void clearAssertionStatus()

  Sets the default assertion status for this class loader to `false` and discards any package defaults or class assertion status settings associated with the class loader. This method is provided so that class loaders can be made to ignore any command line or persistent assertion status settings and "start with a clean slate."

  Since:
    1.4

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD